Index: src/Fl_Pixmap.cxx
===================================================================
--- src/Fl_Pixmap.cxx	(revision 12216)
+++ src/Fl_Pixmap.cxx	(working copy)
@@ -3,7 +3,7 @@
 //
 // Pixmap drawing code for the Fast Light Tool Kit (FLTK).
 //
-// Copyright 1998-2015 by Bill Spitzak and others.
+// Copyright 1998-2017 by Bill Spitzak and others.
 //
 // This library is free software. Distribution and use rights are outlined in
 // the file "COPYING" which should have been included with this file.  If this
@@ -42,6 +42,7 @@
   if (w()<0 && data()) {
     fl_measure_pixmap(data(), W, H);
     w(W); h(H);
+    cache_scale_ = 1;
   }
 }
 
Index: src/Fl_Screen_Driver.cxx
===================================================================
--- src/Fl_Screen_Driver.cxx	(revision 12216)
+++ src/Fl_Screen_Driver.cxx	(working copy)
@@ -3,7 +3,7 @@
 //
 // All screen related calls in a driver style class.
 //
-// Copyright 1998-2016 by Bill Spitzak and others.
+// Copyright 1998-2017 by Bill Spitzak and others.
 //
 // This library is free software. Distribution and use rights are outlined in
 // the file "COPYING" which should have been included with this file.  If this
@@ -24,6 +24,7 @@
 #include <FL/Fl_Group.H>
 #include <FL/Fl_Window.H>
 #include <FL/Fl_Input.H>
+#include <FL/Fl_Window_Driver.H>
 
 char Fl_Screen_Driver::bg_set = 0;
 char Fl_Screen_Driver::bg2_set = 0;
@@ -110,7 +111,7 @@
 
 
 // Return the number of pixels common to the two rectangular areas
-static inline float fl_intersection(int x1, int y1, int w1, int h1,
+float Fl_Screen_Driver::fl_intersection(int x1, int y1, int w1, int h1,
                                     int x2, int y2, int w2, int h2)
 {
   if(x1+w1 < x2 || x2+w2 < x1 || y1+h1 < y2 || y2+h2 < y1)
@@ -154,7 +155,7 @@
 }
 
 uchar *Fl_Screen_Driver::read_image(uchar *p, int X, int Y, int w, int h, int alpha) {
-  uchar *image_data;
+  uchar *image_data = NULL;
   Fl_RGB_Image *img;
   if (fl_find(fl_window) == 0) { // read from off_screen buffer
     img = read_win_rectangle(p, X, Y, w, h, alpha);
@@ -165,14 +166,16 @@
   } else {
     img = traverse_to_gl_subwindows(Fl_Window::current(), p, X, Y, w, h, alpha, NULL);
   }
-  if (img->w() > w) {
-    Fl_RGB_Image *img2 = (Fl_RGB_Image*)img->copy(w, h);
+  if (img) {
+    if (img->w() > w) {
+      Fl_RGB_Image *img2 = (Fl_RGB_Image*)img->copy(w, h);
+      delete img;
+      img = img2;
+    }
+    img->alloc_array = 0;
+    image_data = (uchar*)img->array;
     delete img;
-    img = img2;
   }
-  img->alloc_array = 0;
-  image_data = (uchar*)img->array;
-  delete img;
   return image_data;
 }
 
@@ -268,7 +271,9 @@
         } else {
           top = full_img->h() - (origin_y - y + img->h());
         }
-        write_image_inside(full_img, img, origin_x - x, top);
+        int nscreen = c->as_window()->driver()->screen_num();
+        float s = Fl::screen_driver()->scale(nscreen);
+        write_image_inside(full_img, img, (origin_x - x) * s, top * s);
         delete img;
       }
     }
Index: src/Fl_Scroll.cxx
===================================================================
--- src/Fl_Scroll.cxx	(revision 12216)
+++ src/Fl_Scroll.cxx	(working copy)
@@ -50,6 +50,7 @@
 //    So widget can just redraw damaged parts.
 //
 void Fl_Scroll::draw_clip(void* v,int X, int Y, int W, int H) {
+printf("draw_clip X=%d Y=%d W=%d H=%d\n",X,Y,W,H);
   fl_push_clip(X,Y,W,H);
   Fl_Scroll* s = (Fl_Scroll*)v;
   // erase background as needed...
Index: src/Fl_Shared_Image.cxx
===================================================================
--- src/Fl_Shared_Image.cxx	(revision 12216)
+++ src/Fl_Shared_Image.cxx	(working copy)
@@ -3,7 +3,7 @@
 //
 // Shared image code for the Fast Light Tool Kit (FLTK).
 //
-// Copyright 1998-2016 by Bill Spitzak and others.
+// Copyright 1998-2017 by Bill Spitzak and others.
 //
 // This library is free software. Distribution and use rights are outlined in
 // the file "COPYING" which should have been included with this file.  If this
@@ -366,9 +366,10 @@
     Fl_Image::draw(X, Y, W, H, cx, cy);
     return;
   }
-  fl_push_clip(X, Y, W, H);
+  bool need_clip = (W != w() || H != h() || cx || cy);
+  if (need_clip) fl_push_clip(X, Y, W, H);
   fl_graphics_driver->draw(this, X-cx, Y-cy);
-  fl_pop_clip();
+  if (need_clip) fl_pop_clip();
 }
 
 /** Draws the shared image to the current surface with its top-left at X,Y */
@@ -379,7 +380,7 @@
   }
   // don't call Fl_Graphics_Driver::draw_scaled(Fl_Image*,...) for an enlarged Fl_Bitmap or Fl_Pixmap
   if (shared->image_->as_rgb_image() || (shared->w() <= shared->image_->w() && shared->h() <= shared->image_->h())) {
-    int done = fl_graphics_driver->draw_scaled(shared->image_, X, Y, shared->w(), shared->h());
+    int done = draw_scaled(shared->image_, X, Y, shared->w(), shared->h());
     if (done) return;
   }
   if (shared->scaled_image_ && (shared->scaled_image_->w() != shared->w() || shared->scaled_image_->h() != shared->h())) {
@@ -401,7 +402,7 @@
  This can be useful to draw a shared image on a drawing surface whose resolution is higher
  than the drawing unit for this surface: all pixels of the original image become available to fill
  an area of the drawing surface sized at <tt>width,height</tt>.
- Examples of such drawing surfaces: laser printers, PostScript files, PDF printers, retina displays on Apple hardware.
+ Examples of such drawing surfaces: laser printers, PostScript files, PDF printers, HiDPI displays.
 
  \param width,height   maximum width and height (in drawing units) to use when drawing the shared image
  \param proportional   if not null, keep the width and height of the shared image proportional to those of its original image
@@ -413,7 +414,7 @@
  \code
  Fl_Box *b = ...  // a box
  Fl_Shared_Image *shared = Fl_Shared_Image::get("/path/to/picture.jpeg"); // read a picture file
- shared->scale(b->w(), b->h(), 1); // set the drawing size of the shared image to the size of the box
+ shared->scale(b->w(), b->h()); // set the drawing size of the shared image to the size of the box
  b->image(shared); // use the shared image as the box image
  b->align(FL_ALIGN_INSIDE | FL_ALIGN_CENTER | FL_ALIGN_CLIP); // the image is to be drawn centered in the box
  \endcode
Index: src/Fl_Widget_Surface.cxx
===================================================================
--- src/Fl_Widget_Surface.cxx	(revision 12216)
+++ src/Fl_Widget_Surface.cxx	(working copy)
@@ -3,7 +3,7 @@
 //
 // Drivers code for the Fast Light Tool Kit (FLTK).
 //
-// Copyright 1998-2016 by Bill Spitzak and others.
+// Copyright 1998-2017 by Bill Spitzak and others.
 //
 // This library is free software. Distribution and use rights are outlined in
 // the file "COPYING" which should have been included with this file.  If this
@@ -22,6 +22,7 @@
 #include <FL/x.H>
 #include <FL/Fl_Shared_Image.H>
 #include <FL/Fl_Window_Driver.H>
+#include <FL/Fl_Screen_Driver.H>
 
 
 /** The constructor.
@@ -153,13 +154,19 @@
   Fl_Window *save_front = Fl::first_window();
   win->show();
   Fl::check();
-  win->driver()->flush(); // makes the window current necessary for fl_read_image
-  uchar *image_data;
-  image_data = fl_read_image(NULL, x, y, w, h);
+  win->driver()->flush(); // makes the window current
+  const uchar *image_data;
+  Fl_RGB_Image *img = Fl_Screen_Driver::traverse_to_gl_subwindows(win, NULL, x, y, w, h, 0, NULL);
+  if (img->w() > w) {
+    Fl_RGB_Image *img2 = (Fl_RGB_Image*)img->copy(w, h);
+    delete img;
+    img = img2;
+  }
+  image_data = img->array;
   if (save_front != win) save_front->show();
   set_current();
   fl_draw_image(image_data, delta_x, delta_y, w, h, 3);
-  delete[] image_data;
+  delete img;
 }
 
 /**
Index: src/Fl_Window_Driver.cxx
===================================================================
--- src/Fl_Window_Driver.cxx	(revision 12216)
+++ src/Fl_Window_Driver.cxx	(working copy)
@@ -4,7 +4,7 @@
 // A base class for platform specific window handling code
 // for the Fast Light Tool Kit (FLTK).
 //
-// Copyright 1998-2016 by Bill Spitzak and others.
+// Copyright 1998-2017 by Bill Spitzak and others.
 //
 // This library is free software. Distribution and use rights are outlined in
 // the file "COPYING" which should have been included with this file.  If this
@@ -247,6 +247,11 @@
   }
 }
 
+int Fl_Window_Driver::screen_num() {
+  if (pWindow->parent()) return pWindow->top_window()->driver()->screen_num();
+  return Fl::screen_num(x(), y(), w(), h());
+}
+
 //
 // End of "$Id$".
 //
Index: src/Fl_x.cxx
===================================================================
--- src/Fl_x.cxx	(revision 12216)
+++ src/Fl_x.cxx	(working copy)
@@ -3,7 +3,7 @@
 //
 // X specific code for the Fast Light Tool Kit (FLTK).
 //
-// Copyright 1998-2016 by Bill Spitzak and others.
+// Copyright 1998-2017 by Bill Spitzak and others.
 //
 // This library is free software. Distribution and use rights are outlined in
 // the file "COPYING" which should have been included with this file.  If this
@@ -601,6 +601,49 @@
   fl_xim_deactivate();
 }
 
+
+#if USE_XFT
+
+// respond to Ctrl-'+' and Ctrl-'-' and Ctrl-'0' (Ctrl-'=' is same as Ctrl-'+') by rescaling all windows
+int Fl_X11_Screen_Driver::scale_handler(int event)
+{
+  if ( event != FL_SHORTCUT || (!Fl::event_ctrl()) ) return 0;
+  int key = Fl::event_key() & ~(FL_SHIFT+FL_CTRL);
+  if (key == '=' || key == '-' || key == '+' || key == '0' || key == 0xE0/* for '0' on Fr keyboard */) {
+    int i, count;
+    if (Fl::grab()) return 0; // don't rescale when menu windows are on
+    Fl_Widget *wid = Fl::focus();
+    if (!wid) return 0;
+    int screen = wid->top_window()->driver()->screen_num();
+    Fl_X11_Screen_Driver *screen_dr = (Fl_X11_Screen_Driver*)Fl::screen_driver();
+    static float initial_scale = screen_dr->scale(screen);
+    static float scaling_values[] = {0.5, 2.f/3, 0.8, 0.9, 1, 1.1, 1.2, 4.f/3, 1.5, 1.7, 2, 2.4, 3,
+      4, 5.5, 6.5, 7.5, 9.75 };
+    float f, old_f = screen_dr->scale(screen)/initial_scale;
+    if (key == '0' || key == 0xE0) f = 1;
+    else {
+      count = sizeof(scaling_values)/sizeof(float);
+      for (i = 0; i < count; i++) {
+        if (old_f >= scaling_values[i] - 1e-4 && (i+1 >= count || old_f < scaling_values[i+1] - 1e-4)) {
+          break;
+        }
+      }
+      if (key == '-') i--; else i++;
+      if (i < 0) i = 0; if (i >= count) i = count - 1;
+      f = scaling_values[i];
+    }
+    if (f == old_f) return 1;
+    screen_dr->rescale_all_windows_from_screen(screen, f*initial_scale);
+    Fl_X11_Screen_Driver::transient_scale_display(f, screen);
+    screen_dr->init_workarea();
+    return 1;
+  }
+  return 0;
+}
+
+#endif // USE_XFT
+
+
 void Fl_X11_Screen_Driver::open_display() {
   if (fl_display) return;
 
@@ -617,6 +660,12 @@
   // the unique GC used by all X windows
   GC gc = XCreateGC(fl_display, RootWindow(fl_display, fl_screen), 0, 0);
   Fl_Graphics_Driver::default_driver().gc(gc);
+  
+#if USE_XFT // scaling does not work without Xft
+  float factor = default_scale_factor();
+  for (int i = 0; i < screen_count(); i++) this->scale(i, factor);
+  Fl::add_handler(scale_handler);
+#endif // USE_XFT
 }
 
 
@@ -719,16 +768,25 @@
   XCloseDisplay(fl_display);
 }
 
-
-void Fl_X11_Screen_Driver::get_mouse(int &xx, int &yy) {
+int Fl_X11_Screen_Driver::get_mouse_unscaled(int &mx, int &my) {
   open_display();
   Window root = RootWindow(fl_display, fl_screen);
-  Window c; int mx,my,cx,cy; unsigned int mask;
-  XQueryPointer(fl_display,root,&root,&c,&mx,&my,&cx,&cy,&mask);
-  xx = mx;
-  yy = my;
+  Window c; int cx,cy; unsigned int mask;
+  XQueryPointer(fl_display, root, &root, &c, &mx, &my, &cx, &cy, &mask);
+#if USE_XFT
+  return screen_num_unscaled(mx, my);
+#else
+  return screen_num(mx, my);
+#endif
 }
 
+
+void Fl_X11_Screen_Driver::get_mouse(int &xx, int &yy) {
+  float s = scale(get_mouse_unscaled(xx, yy));
+  xx = xx/s;
+  yy = yy/s;
+}
+
 ////////////////////////////////////////////////////////////////
 // Code used for paste and DnD into the program:
 
@@ -1079,14 +1137,19 @@
 static int px, py;
 static ulong ptime;
 
-static void set_event_xy() {
+static void set_event_xy(Fl_Window *win) {
 #  if CONSOLIDATE_MOTION
   send_motion = 0;
 #  endif
-  Fl::e_x_root  = fl_xevent->xbutton.x_root;
-  Fl::e_x       = fl_xevent->xbutton.x;
-  Fl::e_y_root  = fl_xevent->xbutton.y_root;
-  Fl::e_y       = fl_xevent->xbutton.y;
+  float s = 1;
+#if USE_XFT
+  Fl_X11_Screen_Driver *d =  (Fl_X11_Screen_Driver*)Fl::screen_driver();
+  s = d->scale(win->driver()->screen_num());
+#endif
+  Fl::e_x_root  = fl_xevent->xbutton.x_root/s;
+  Fl::e_x       = fl_xevent->xbutton.x/s;
+  Fl::e_y_root  = fl_xevent->xbutton.y_root/s;
+  Fl::e_y       = fl_xevent->xbutton.y/s;
   Fl::e_state   = fl_xevent->xbutton.state << 16;
   fl_event_time = fl_xevent->xbutton.time;
 #  ifdef __sgi
@@ -1203,12 +1266,6 @@
   return XKeycodeToKeysym(d, k, i);
 }
 
-static void fl_init_workarea()
-{
-  Fl_X11_Screen_Driver *drv = (Fl_X11_Screen_Driver*)Fl::screen_driver();
-  drv->init_workarea();
-}
-
 int fl_handle(const XEvent& thisevent)
 {
   XEvent xevent = thisevent;
@@ -1236,18 +1293,23 @@
 
   if (fl_xim_ic && XFilterEvent((XEvent *)&xevent, 0))
       return(1);
+  Fl_X11_Screen_Driver *x11_screen_driver = (Fl_X11_Screen_Driver*)Fl::screen_driver();
   
 #if USE_XRANDR  
   if( XRRUpdateConfiguration_f && xevent.type == randrEventBase + RRScreenChangeNotify) {
     XRRUpdateConfiguration_f(&xevent);
     Fl::call_screen_init();
-    fl_init_workarea();
+#if USE_XFT
+    float factor = x11_screen_driver->default_scale_factor();
+    for (int screen = 0; screen <= Fl::screen_count(); screen++)
+      x11_screen_driver->rescale_all_windows_from_screen(screen, factor);
+#endif // USE_XFT
     Fl::handle(FL_SCREEN_CONFIGURATION_CHANGED, NULL);
   }
-#endif
+#endif // USE_XRANDR
 
   if (xevent.type == PropertyNotify && xevent.xproperty.atom == fl_NET_WORKAREA) {
-    fl_init_workarea();
+    x11_screen_driver->init_workarea();
   }
   
   switch (xevent.type) {
@@ -1647,8 +1709,17 @@
 #  endif
 
   case GraphicsExpose:
-    window->damage(FL_DAMAGE_EXPOSE, xevent.xexpose.x, xevent.xexpose.y,
-                   xevent.xexpose.width, xevent.xexpose.height);
+    {
+#if USE_XFT
+      int ns = window->driver()->screen_num();
+      float s = Fl::screen_driver()->scale(ns);
+      window->damage(FL_DAMAGE_EXPOSE, xevent.xexpose.x/s, xevent.xexpose.y/s,
+                     xevent.xexpose.width/s + 2, xevent.xexpose.height/s + 2);
+#else
+      window->damage(FL_DAMAGE_EXPOSE, xevent.xexpose.x, xevent.xexpose.y,
+                     xevent.xexpose.width, xevent.xexpose.height);
+#endif
+     }
     return 1;
 
   case FocusIn:
@@ -1867,13 +1938,13 @@
     // replace XK_ISO_Left_Tab (Shift-TAB) with FL_Tab (modifier flags are set correctly by X11)
     if (Fl::e_keysym == 0xfe20) Fl::e_keysym = FL_Tab;
 
-    set_event_xy();
+    set_event_xy(window);
     Fl::e_is_click = 0; }
     break;
   
   case ButtonPress:
     Fl::e_keysym = FL_Button + xevent.xbutton.button;
-    set_event_xy();
+    set_event_xy(window);
     Fl::e_dx = Fl::e_dy = 0;
     if (xevent.xbutton.button == Button4) {
       Fl::e_dy = -1; // Up
@@ -1924,7 +1995,7 @@
     break;
 
   case MotionNotify:
-    set_event_xy();
+    set_event_xy(window);
 #  if CONSOLIDATE_MOTION
     send_motion = fl_xmousewin = window;
     in_a_window = true;
@@ -1938,7 +2009,7 @@
 
   case ButtonRelease:
     Fl::e_keysym = FL_Button + xevent.xbutton.button;
-    set_event_xy();
+    set_event_xy(window);
     Fl::e_state &= ~(FL_BUTTON1 << (xevent.xbutton.button-1));
     if (xevent.xbutton.button == Button4 ||
         xevent.xbutton.button == Button5) return 0;
@@ -1951,7 +2022,7 @@
   case EnterNotify:
     if (xevent.xcrossing.detail == NotifyInferior) break;
     // XInstallColormap(fl_display, Fl_X::i(window)->colormap);
-    set_event_xy();
+    set_event_xy(window);
     Fl::e_state = xevent.xcrossing.state << 16;
     event = FL_ENTER;
 
@@ -1967,7 +2038,7 @@
 
   case LeaveNotify:
     if (xevent.xcrossing.detail == NotifyInferior) break;
-    set_event_xy();
+    set_event_xy(window);
     Fl::e_state = xevent.xcrossing.state << 16;
     fl_xmousewin = 0;
     in_a_window = false; // make do_queued_events produce FL_LEAVE event
@@ -1992,10 +2063,39 @@
     Window cr; int X, Y, W = actual.width, H = actual.height;
     XTranslateCoordinates(fl_display, fl_xid(window), actual.root,
                           0, 0, &X, &Y, &cr);
+#if USE_XFT // detect when window changes screen
+    int num = 0;
+    Fl_X11_Screen_Driver *d = (Fl_X11_Screen_Driver*)Fl::screen_driver();
+    num = d->screen_num_unscaled(X, Y, actual.width, actual.height);
+    Fl_X11_Window_Driver *wd = Fl_X11_Window_Driver::driver(window);
+    int olds = wd->screen_num();
+    float s = d->scale(num);
+    if (num != olds) {
+      if (s != d->scale(olds) &&
+          !Fl_X11_Window_Driver::data_for_resize_window_between_screens_.busy &&
+          window->user_data() != &Fl_X11_Screen_Driver::transient_scale_display) {
+        Fl_X11_Window_Driver::data_for_resize_window_between_screens_.busy = true;
+        Fl_X11_Window_Driver::data_for_resize_window_between_screens_.screen = num;
+        // resize_after_screen_change() works also if called here, but calling it
+        // a second later gives a more pleasant user experience when moving windows between distinct screens
+        Fl::add_timeout(1, Fl_X11_Window_Driver::resize_after_screen_change, window);
+      }
+      wd->screen_num(num);
+    }
+#endif // USE_XFT
 
     // tell Fl_Window about it and set flag to prevent echoing:
     resize_bug_fix = window;
+#if USE_XFT    
+    if (!Fl_X11_Window_Driver::data_for_resize_window_between_screens_.busy &&
+       ( W != int(window->w()*s) || H != int(window->h()*s) ) ) {
+        window->resize(X/s, Y/s, W/s, H/s);
+    } else {
+      window->position(X/s, Y/s);
+    }
+#else
     window->resize(X, Y, W, H);
+#endif
     break; // allow add_handler to do something too
     }
 
@@ -2017,7 +2117,13 @@
     // tell Fl_Window about it and set flag to prevent echoing:
     if ( !wasXExceptionRaised() ) {
       resize_bug_fix = window;
-      window->position(xpos, ypos);
+#if USE_XFT
+      int ns = window->driver()->screen_num();
+      float s = Fl::screen_driver()->scale(ns);
+#else
+      float s = 1;
+#endif
+      window->position(xpos/s, ypos/s);
     }
     break;
     }
@@ -2066,15 +2172,16 @@
   }
 
   if (resize_from_program && shown()) {
+    float s = Fl::screen_driver()->scale(screen_num());
     if (is_a_resize) {
       if (!pWindow->resizable()) pWindow->size_range(w(), h(), w(), h());
       if (is_a_move) {
-        XMoveResizeWindow(fl_display, fl_xid(pWindow), X, Y, W>0 ? W : 1, H>0 ? H : 1);
+        XMoveResizeWindow(fl_display, fl_xid(pWindow), X*s, Y*s, W>0 ? W*s : 1, H>0 ? H*s : 1);
       } else {
-        XResizeWindow(fl_display, fl_xid(pWindow), W>0 ? W : 1, H>0 ? H : 1);
+        XResizeWindow(fl_display, fl_xid(pWindow), W>0 ? W*s : 1, H>0 ? H*s : 1);
       }
     } else
-      XMoveWindow(fl_display, fl_xid(pWindow), X, Y);
+      XMoveWindow(fl_display, fl_xid(pWindow), X*s, Y*s);
   }
 }
 
@@ -2179,7 +2286,7 @@
     right = fullscreen_screen_right();
     
     if ((top < 0) || (bottom < 0) || (left < 0) || (right < 0)) {
-      top = Fl::screen_num(x(), y(), w(), h());
+      top = screen_num();
       bottom = top;
       left = top;
       right = top;
@@ -2361,11 +2468,31 @@
     fl_background_pixel = -1;
     mask |= CWBackPixel;
   }
-
+  // reproduce the window cursor if a window is hidden and then recreated (e.g., rescaled)
+  attr.cursor = Fl_X11_Window_Driver::driver(win)->current_cursor_;
+  mask |= CWCursor;
+  float s = 1;
+#if USE_XFT
+  //compute adequate screen where to put the window
+  int nscreen = 0;
+  if (win->parent()) {
+    nscreen = win->top_window()->driver()->screen_num();
+  } else if (win->force_position() && Fl_X11_Window_Driver::driver(win)->screen_num_ >= 0) {
+    nscreen = win->driver()->screen_num();
+  } else {
+    Fl_Window *hint = Fl::first_window();
+    if (hint) {
+      nscreen = hint->top_window()->driver()->screen_num();
+    }
+  }
+  Fl_X11_Window_Driver::driver(win)->screen_num(nscreen);
+  s = Fl::screen_driver()->scale(nscreen);
+//if (!win->parent()) printf("win creation on screen #%d\n", nscreen);
+#endif
   Fl_X* xp =
     set_xid(win, XCreateWindow(fl_display,
                                root,
-                               X, Y, W, H,
+                               X*s, Y*s, W*s, H*s,
                                0, // borderwidth
                                visual->depth,
                                InputOutput,
@@ -2525,12 +2652,20 @@
 
   XSizeHints *hints = XAllocSizeHints();
   // memset(&hints, 0, sizeof(hints)); jreiser suggestion to fix purify?
-  hints->min_width = minw();
-  hints->min_height = minh();
-  hints->max_width = maxw();
-  hints->max_height = maxh();
-  hints->width_inc = dw();
-  hints->height_inc = dh();
+  float s = Fl::screen_driver()->scale(screen_num());
+
+  hints->min_width = s*minw();
+  hints->min_height = s*minh();
+  hints->max_width = s*maxw();
+  hints->max_height = s*maxh();
+  if (int(s) == s) { // use win size increment value only if scale is an integer. Is it possible to do better?
+    hints->width_inc = s*dw();
+    hints->height_inc = s*dh();
+  } else {
+    hints->width_inc = 0;
+    hints->height_inc = 0;
+  }
+  
   hints->win_gravity = StaticGravity;
 
   // see the file /usr/include/X11/Xm/MwmUtil.h:
@@ -2547,8 +2682,8 @@
       // unfortunately we can't set just one maximum size.  Guess a
       // value for the other one.  Some window managers will make the
       // window fit on screen when maximized, others will put it off screen:
-      if (hints->max_width < hints->min_width) hints->max_width = Fl::w();
-      if (hints->max_height < hints->min_height) hints->max_height = Fl::h();
+      if (hints->max_width < hints->min_width) hints->max_width = Fl::w()*s;
+      if (hints->max_height < hints->min_height) hints->max_height = Fl::h()*s;
     }
     if (hints->width_inc && hints->height_inc) hints->flags |= PResizeInc;
     if (aspect()) {
@@ -2566,8 +2701,8 @@
 
   if (force_position()) {
     hints->flags |= USPosition;
-    hints->x = w->x();
-    hints->y = w->y();
+    hints->x = s*w->x();
+    hints->y = s*w->y();
   }
 
   if (!w->border()) {
@@ -2730,6 +2865,7 @@
 #undef cache_cursor
 
   XDefineCursor(fl_display, fl_xid(pWindow), xc);
+  current_cursor_ = xc;
 
   return 1;
 }
@@ -2895,6 +3031,7 @@
   //printer.print_window_part( win, 0,0, win->w(), win->h(), - win->w()/2, - win->h()/2 );
 #else  
   printer.print_window(win);
+  //printer.print_window_part( win, 0,0, win->w(), win->h(), 0,0 );
 #endif
 
   printer.end_page();
@@ -2909,8 +3046,9 @@
   Fl_Window *win = Fl::first_window();
   if (!win) return;
   Fl_Copy_Surface *surf = new Fl_Copy_Surface(win->decorated_w(), win->decorated_h());
-  surf->set_current();
+  Fl_Surface_Device::push_current(surf);
   surf->draw_decorated_window(win); // draw the window content
+  Fl_Surface_Device::pop_current();
   delete surf; // put the window on the clipboard
   o->window()->show();
 }
Index: src/drivers/OpenGL/Fl_OpenGL_Display_Device.cxx
===================================================================
--- src/drivers/OpenGL/Fl_OpenGL_Display_Device.cxx	(revision 12216)
+++ src/drivers/OpenGL/Fl_OpenGL_Display_Device.cxx	(working copy)
@@ -3,7 +3,7 @@
 //
 // implementation of class Fl_Gl_Device_Plugin for the Fast Light Tool Kit (FLTK).
 //
-// Copyright 2010-2014 by Bill Spitzak and others.
+// Copyright 2010-2017 by Bill Spitzak and others.
 //
 // This library is free software. Distribution and use rights are outlined in
 // the file "COPYING" which should have been included with this file.  If this
@@ -93,7 +93,8 @@
 #if defined(FL_PORTING)
 #  pragma message "FL_PORTING: check whether the default Fl_OpenGL_Display_Device::capture_gl_rectangle() works for your platform"
 #endif
-
+#include <FL/Fl_Screen_Driver.H>
+#include <FL/Fl_Window_Driver.H>
 Fl_RGB_Image* Fl_OpenGL_Display_Device::capture_gl_rectangle(Fl_Gl_Window *glw, int x, int y, int w, int h)
 /* captures a rectangle of a Fl_Gl_Window window, and returns it as a RGB image
  */
@@ -106,6 +107,12 @@
   glPixelStorei(GL_PACK_ROW_LENGTH, 0);
   glPixelStorei(GL_PACK_SKIP_ROWS, 0);
   glPixelStorei(GL_PACK_SKIP_PIXELS, 0);
+  //
+  int ns = glw->driver()->screen_num();
+  float s = Fl::screen_driver()->scale(ns);
+  if (s != 1) {
+    x *= s; y *= s; w *= s; h *= s;
+  }
   // Read a block of pixels from the frame buffer
   int mByteWidth = w * 3;
   mByteWidth = (mByteWidth + 3) & ~3;    // Align to 4 bytes
Index: src/drivers/X11/Fl_X11_Screen_Driver.H
===================================================================
--- src/drivers/X11/Fl_X11_Screen_Driver.H	(revision 12216)
+++ src/drivers/X11/Fl_X11_Screen_Driver.H	(working copy)
@@ -4,7 +4,7 @@
 // Definition of X11 Screen interface
 // for the Fast Light Tool Kit (FLTK).
 //
-// Copyright 2010-2016 by Bill Spitzak and others.
+// Copyright 2010-2017 by Bill Spitzak and others.
 //
 // This library is free software. Distribution and use rights are outlined in
 // the file "COPYING" which should have been included with this file.  If this
@@ -39,13 +39,29 @@
     short y_org;
     short width;
     short height;
+#if USE_XFT
+    float scale;
+#endif
   } FLScreenInfo;
   FLScreenInfo screens[MAX_SCREENS];
   float dpi[MAX_SCREENS][2];
   int poll_or_select();
   int poll_or_select_with_delay(double time_to_wait);
+  int get_mouse_unscaled(int &xx, int &yy);
 
 public:
+#if USE_XFT // scaling does not work without Xft
+  virtual float scale(int n) {return screens[n].scale;}
+  void scale(int n, float f) { screens[n].scale = f;}
+  float default_scale_factor();
+  int screen_num_unscaled(int x, int y);
+  int screen_num_unscaled(int x, int y, int w, int h);
+  void rescale_all_windows_from_screen(int screen, float old_f);
+  static void transient_scale_display(float f, int nscreen);
+  static int scale_handler(int event);
+  virtual void screen_xywh(int &X, int &Y, int &W, int &H);
+#endif
+  
   static int ewmh_supported();
   static void copy_image(const unsigned char* data, int W, int H, int destination);
   // --- display management
@@ -91,7 +107,6 @@
   virtual void offscreen_size(Fl_Offscreen o, int &width, int &height);
 };
 
-
 #endif // FL_X11_SCREEN_DRIVER_H
 
 //
